generic: more tests should clean up TESTDIR on success
[xfstests-dev.git] / tests / generic / 074
1 #! /bin/bash
2 # FS QA Test No. 074
3 #
4 # fstest
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=0        # success is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     rm -rf $fstest_dir.* $tmp.*
37 }
38
39 # get standard environment, filters and checks
40 . ./common/rc
41 . ./common/filter
42
43 _supported_fs generic
44 _supported_os IRIX Linux
45 _require_test
46
47 rm -f $seqres.full
48 fstest_dir=$TEST_DIR/fstest
49
50 _do_test()
51 {
52     _n="$1"
53     _param="$2"
54
55     out=$fstest_dir.$_n
56     rm -rf $out
57     if ! mkdir $out
58     then
59         echo "    failed to mkdir $out"
60         status=1
61         exit
62     fi
63
64     _filter_param=`echo "$_param" | sed\
65         -e 's/-n [0-9][0-9]*/-n children/' \
66         -e 's/-l [0-9][0-9]*/-l loops/' \
67         -e 's/-f [0-9][0-9]*/-f files/'`
68
69     echo ""
70     echo "-----------------------------------------------"
71     echo "fstest.$_n : $_filter_param"
72     echo "-----------------------------------------------"
73     if ! $here/src/fstest $_param -p $out >>$seqres.full
74     then
75         echo "    fstest ($_param) returned $? - see $seqres.full"
76         status=1
77         exit
78     fi
79
80     _check_test_fs
81 }
82
83 _usage()
84 {
85     echo "$0: [-f files] [-l loops] [-n children]"
86 }
87
88 _process_args()
89 {
90     while getopts "f:l:n:?" c $@
91     do
92         case $c
93         in
94             f)
95                 numfiles=$OPTARG
96                 param_type="$param_type, overidde -f"
97                 ;;
98             l)
99                 numloops=$OPTARG
100                 param_type="$param_type, overidde -l"
101                 ;;
102             n)
103                 numchildren=$OPTARG
104                 param_type="$param_type, overidde -n"
105                 ;;
106             ?)
107                 _usage
108                 exit    
109                 ;;
110         esac
111     done
112 }
113
114 #
115 # set params
116 # These params can take a while on different CPUs/OSs
117 # so we set them differently for different machines
118 #
119 if [ $HOSTOS == "IRIX" ]; then 
120     if uname -R | grep -iq debug; then 
121         # e.g. getting around 37secs for 1,1,1 on IP30 debug
122         numchildren=2
123         numloops=1
124         numfiles=2
125         param_type="IRIX debug"
126     else
127         # getting around 1 sec 1,1,1 - 10secs 1,10,1 on IP30 nondebug
128         numloops=2
129         numfiles=3
130         numchildren=3
131         param_type="IRIX nondebug"
132     fi
133 elif [ $HOSTOS == "Linux" ]; then
134     if uname -a | grep -q SMP; then
135         numloops=10
136         numfiles=5
137         numchildren=3
138         param_type="Linux SMP"
139     else
140         numloops=2
141         numfiles=3
142         numchildren=3
143         param_type="Linux UP"
144     fi
145 else
146     numloops=1
147     numfiles=1
148     numchildren=1
149     param_type="Default"
150 fi
151
152 # can override the params here
153 _process_args "$@"
154
155 echo "Params are for $param_type" >>$seqres.full
156 echo "Params: n = $numchildren l = $numloops f = $numfiles" >>$seqres.full
157
158 _check_test_fs
159
160 # Options:
161 # -F                    generate files with holes  (default=no)
162 # -n num_children       set number of child processes (default=1)
163 # -f num_files          set number of files (default=1)
164 # -s file_size          set file sizes (default=1MiB)
165 # -b block_size         set block (IO) size (default=1024)
166 # -l loops              set loop count (default=100)
167 # -m                    use mmap (default=no)
168 # -S                    use synchronous IO (default=no)
169 # -P                    preallocate space (default=no)
170
171 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
172 size30=`expr 30 \* 1024 \* 1024`        # 30 megabytes
173
174 _do_test 0 "-l $numloops"
175
176 _do_test 1 "-l $numloops -s $size10 -b 8192 -m"
177
178 _do_test 2 "-n $numchildren -F -l $numloops -f $numfiles -s $size30 -b 512"
179
180 _do_test 3 "-n $numchildren -F -l $numloops -f $numfiles -s $size30 -b 512 -m"
181
182 _do_test 4 "-n $numchildren -F -l $numloops -f $numfiles -s $size10 -b 512 -mS"